
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;
import com.nttdocomo.net.*;
import java.io.*;
import javax.microedition.io.*;

public class iBBS extends IApplication implements SoftKeyListener, ComponentListener {

	String method = "GET";

	Panel mainPanel = null;
	ListBox messageList = null;
	Button writeButton = null;
	Button viewButton = null;
	Button reloadButton = null;

	Panel writePanel = null;
	TextBox titleText = null;
	TextBox messageText = null;

	Panel errorPanel = null;
	TextBox errorText = null;

	MessageCanvas canvas = null;
	String[] titles = null;
	String[] messages = null;

	public void start(){
		PhoneSystem.setAttribute(PhoneSystem.DEV_BACKLIGHT,PhoneSystem.ATTR_BACKLIGHT_ON);

		mainPanel = new Panel();
		mainPanel.setTitle("үވꗗ");

		mainPanel.setSoftKeyListener(this);
		mainPanel.setSoftLabel(Frame.SOFT_KEY_1,"I");
		mainPanel.setSoftLabel(Frame.SOFT_KEY_2,method);

		mainPanel.setComponentListener(this);

		messageList = new ListBox(ListBox.RADIO_BUTTON,5);
		writeButton = new Button("VK");
		reloadButton = new Button("XV");
		viewButton = new Button("\");

		mainPanel.add(messageList);
		mainPanel.add(writeButton);
		mainPanel.add(reloadButton);
		mainPanel.add(viewButton);

		writePanel = new Panel();
		writePanel.setTitle("");
		writePanel.setSoftKeyListener(this);
		writePanel.setSoftLabel(Frame.SOFT_KEY_1,"߂");
		writePanel.setSoftLabel(Frame.SOFT_KEY_2,"M");

		titleText = new TextBox(null,20,1,TextBox.DISPLAY_ANY);
		messageText = new TextBox(null,20,20,TextBox.DISPLAY_ANY);

		writePanel.add(titleText);
		writePanel.add(messageText);

		errorPanel = new Panel();
		errorPanel.setTitle("error");
		errorPanel.setSoftKeyListener(this);
		errorPanel.setSoftLabel(Frame.SOFT_KEY_1,"߂");

		errorText = new TextBox("none",20,20,TextBox.DISPLAY_ANY);
		errorPanel.add(errorText);

		canvas = new MessageCanvas(mainPanel);

		Display.setCurrent(mainPanel);
	}

	public void softKeyPressed(int key){
	}
	public void softKeyReleased(int key){
		Panel panel = (Panel)(Display.getCurrent());

		if(key==Frame.SOFT_KEY_1){
			if(panel==mainPanel){
				terminate();
			}else{
				Display.setCurrent(mainPanel);
			}
		}
		if(key==Frame.SOFT_KEY_2){
			if(panel==mainPanel){
				if(method.equals("GET")){
					method = "POST";
				}else{
					method = "GET";
				}
				mainPanel.setSoftLabel(Frame.SOFT_KEY_2,method);
			}else if(panel==writePanel){
				String title = titleText.getText();
				String mes = messageText.getText();
				if(sendMessage("title="+title+"&message="+mes)){
					titleText.setText("");
					messageText.setText("");
					Display.setCurrent(mainPanel);
				}
			}
		}
	}

	public void componentAction(Component source,int type,int param){
		if(type==ComponentListener.BUTTON_PRESSED){
			if(source==writeButton){
				Display.setCurrent(writePanel);
			}else if(source==reloadButton){
				if(sendMessage("method=reload")){
					Display.setCurrent(mainPanel);
				}
			}else if(source==viewButton){
				int index = messageList.getSelectedIndex();
				if(index!=-1){
					canvas.setData(titles[ index ],messages[ index ]);
					Display.setCurrent(canvas);
				}
			}
		}
	}

	boolean sendMessage(String message){
		byte[] buf = null;
		String url = getSourceURL() + "ibbs.cgi";

		if(method.equals("GET")){
			buf = methodGET(url,message);
		}else{
			buf = methodPOST(url,message);
		}

		byte[] buf = access(message);
		if(buf==null) return false;
		try{
			String data = "";
			try{
				data = new String(buf,"SJIS");
			}catch(UnsupportedEncodingException e){
			}
			String[] mes = new String[5];

			int j = 0;
			int t;
			while((t=data.indexOf("%%\n"))!=-1){
				mes[j] = data.substring(0,t);
				data = data.substring(t+"%%\n".length());
				j++;
			}
			int length = j;
			titles = new String[length];
			messages = new String[length];
			for(int i=0;i<length;i++){
				int index = mes[i].indexOf("@@");
				titles[i] = mes[i].substring(0,index);
				messages[i] = mes[i].substring(index+"@@".length());
			}

			messageList.removeAll();
			for(int i=0;i<titles.length;i++){
				messageList.append(titles[i]);
			}

			return true;
		}catch(Exception e){
			errorText.setText(e.toString());
			Display.setCurrent(errorPanel);
		}
		return false;
	}
	byte[] methodGET(String url,String data){
		HttpConnection con = null;
		InputStream in = null;
		byte[] buf = null;

		try{
			url = url + "?" + URLEncoder.encode(data);
			con = (HttpConnection)Connector.open(url,Connector.READ,true);
			con.setRequestMethod(HttpConnection.GET);

			con.connect();

			int length = (int)con.getLength();
			in = con.openInputStream();
			if(length>0){
				buf = new byte[length];
				in.read(buf);
			}else{
				ByteArrayOutputStream bout = new ByteArrayOutputStream();
				byte[] b = new byte[128];
				int t;
				while((t=in.read(b))!=-1){
					bout.write(b,0,t);
				}
				buf = bout.toByteArray();
			}
		}catch(ConnectionException ce){
			errorText.setText(ce.toString() + "\nstatus = "+ce.getStatus());
			Display.setCurrent(errorPanel);
		}catch(Exception e){
			errorText.setText(e.toString());
			Display.setCurrent(errorPanel);
		}finally{
			try{
				if(in!=null){
					in.close();
					in = null;
				}
				if(con!=null){
					con.close();
					con = null;
				}
			}catch(Exception e){
			}
		}
		return buf;
	}
	byte[] methodPOST(String url,String data){
		HttpConnection con = null;
		OutputStream out = null;
		InputStream in = null;
		byte[] buf = null;

		try{
			con = (HttpConnection)Connector.open(url,Connector.READ_WRITE,true);
			con.setRequestMethod(HttpConnection.POST);
			con.setRequestProperty("Content-type","text/plain");

			out = con.openOutputStream();
			out.write(data.getBytes());
			out.close();
			out = null;

			con.connect();

			int length = (int)con.getLength();
			in = con.openInputStream();
			if(length>0){
				buf = new byte[length];
				in.read(buf);
			}else{
				ByteArrayOutputStream bout = new ByteArrayOutputStream();
				byte[] b = new byte[128];
				int t;
				while((t=in.read(b))!=-1){
					bout.write(b,0,t);
				}
				buf = bout.toByteArray();
				bout.close();
			}
		}catch(ConnectionException ce){
			errorText.setText(ce.toString() + "\nstatus = "+ce.getStatus());
			Display.setCurrent(errorPanel);
		}catch(Exception e){
			errorText.setText(e.toString());
			Display.setCurrent(errorPanel);
		}finally{
			try{
				if(out!=null){
					out.close();
					out = null;
				}
				if(in!=null){
					in.close();
					in = null;
				}
				if(con!=null){
					con.close();
					con = null;
				}
			}catch(Exception e){
			}
		}
		return buf;
	}
}
class MessageCanvas extends Canvas {
	int width,height;
	Panel parentPanel = null;

	String title = null;
	String message = null;
	int y = 0;
	Image backImage = null;

	public MessageCanvas(Panel panel){
		parentPanel = panel;
		setSoftLabel(Frame.SOFT_KEY_1,"߂");

		width = getWidth();height = getHeight();

		try{
			MediaImage mi = MediaManager.getImage("resource:///image.gif");
			mi.use();
			backImage = mi.getImage();
		}catch(Exception e){
		}
	}

	public void paint(Graphics g){
		g.lock();

		if(backImage!=null){
			int iw = backImage.getWidth();
			int ih = backImage.getHeight();
			for(int iy=0;iy<(height/ih)+1;iy++){
				for(int ix=0;ix<(width/iw)+1;ix++){
					g.drawImage(backImage,ix*iw,iy*ih);
				}
			}
		}else{
			g.clearRect(0,0,width,height);
		}

		Font font = Font.getDefaultFont();
		int fontHeight = font.getHeight();		

		if(title!=null){
			g.drawString(":"+title,0,fontHeight+y*fontHeight);
			g.drawLine(0,fontHeight+y*fontHeight,width,fontHeight+y*fontHeight);
		}
		if(message!=null){
			int len = message.length();
			char[] data = new char[len];
			message.getChars(0,len,data,0);
			int startIndex = 0;
			int endIndex = 0;
			int dy = fontHeight*y + fontHeight;
			while(len>0){
				endIndex = font.getLineBreak(message,startIndex,len,width);
				g.drawChars(data,0,fontHeight+dy,startIndex,endIndex-startIndex);
				dy += fontHeight;
				len = len - (endIndex-startIndex);
				startIndex = endIndex;
			}
		}

		g.unlock(false);
	}

	public void processEvent(int type,int param){
		if(type==Display.KEY_RELEASED_EVENT){
			if(param==Display.KEY_SOFT1){
				Display.setCurrent(parentPanel);
			}
		}
		if(type==Display.KEY_PRESSED_EVENT){
			int key = getKeypadState();
			if((key&(1<<Display.KEY_UP))!=0&&y<0){
				y += 1;
			}
			if((key&(1<<Display.KEY_DOWN))!=0){
				y -= 1;
			}
			repaint();
		}
	}

	void setData(String title,String message){
		this.title = title;
		this.message = message;
		y = 0;
	}
}
